﻿using System;
using System.IO;
using System.Reflection;
using System.Reflection.Emit;
using System.Text;
using Microsoft.AspNetCore.Authentication.JwtBearer;
using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.IdentityModel.Tokens;
using Prometheus;
using Swashbuckle.AspNetCore.Swagger;
using Grafana;

namespace RateMeDemo
{
    public class Startup
    {
        public Startup(IConfiguration configuration)
        {
            Configuration = configuration;
        }

        public IConfiguration Configuration { get; }

        /// <summary>
        /// ConfigureServices(ISeviceCollection services)
        /// This method gets called by the runtime. Use this method to add services to the container.
        /// Calls: ConfigureSwagger(services), ConfigureJWT(services)
        /// </summary>
        /// <returns></returns>
        public void ConfigureServices(IServiceCollection services)
        {
            ConfigureCORS(services);

            services.AddMvc().SetCompatibilityVersion(CompatibilityVersion.Version_2_1);

            ConfigureSwagger(services);

            ConfigureJWT(services);
        }

        /// <summary>
        /// Configure(IApplicationBuilder app, IHostingEnvironment env)
        /// This method gets called by the runtime. Use this method to configure the HTTP request pipeline.
        /// Configuration: app.UseHttpsRedirection(), app.UseMvc(), UseSwagger(app), app.UseAuthentication(), app.UseMetricServer()
        /// </summary>
        /// <returns></returns>
        public void Configure(IApplicationBuilder app, IHostingEnvironment env)
        {
            if (env.IsDevelopment())
            {
                app.UseDeveloperExceptionPage();
            }
            else
            {
                app.UseHsts();
            }

            //configuration for CORS Policy
            app.UseCors("EnableCORS");

            //configuration for Prometheus metrics
            app.UseMetricServer();
            app.UseRequestMiddleware();
            
            app.UseHttpMetrics(options =>
            {
                options.RequestCount.Enabled = false;

                options.RequestDuration.Histogram = Metrics.CreateHistogram("myapp_http_request_duration_seconds", "Some help text",
                    new HistogramConfiguration
                    {
                        Buckets = Histogram.LinearBuckets(start: 1, width: 1, count: 64),
                        LabelNames = new[] { "code", "method", "controller", "action" }
                    });
            });
            //This counts the requests for each endpoint and the method.
            var counter = Metrics.CreateCounter("PathCounter", "Counts requests to endpoints", new CounterConfiguration
            {
                LabelNames = new[] { "method", "endpoint" }
            });
            app.Use((context, next) =>
            {
                counter.WithLabels(context.Request.Method, context.Request.Path).Inc();
                return next();
            });

            app.UseHttpsRedirection();
            app.UseMvc();

            //configuration for Swagger usage
            UseSwagger(app);

            //configuration for JWT token authentification
            app.UseAuthentication();
        }

        /// <summary>
        /// ConfigureSwagger(IServiceCollection services)
        /// </summary>
        /// <returns></returns>
        public void ConfigureSwagger(IServiceCollection services)
        {
            //This line adds Swagger generation services to our container.
            services.AddSwaggerGen(c =>
            {
                //The generated Swagger JSON file will have these properties.
                c.SwaggerDoc("v1", new Info
                {
                    Title = "Swagger XML Api RateMe Demo",
                    Version = "v1",
                    Description = "API used for RateMe Demo App ASP.NET Core",
                    TermsOfService = "None",
                    Contact = new Contact
                    {
                        Name = "BlueDot.dev",
                        Email = string.Empty,
                        Url = "https://bluedot.dev"
                    },
                });

                //Locate the XML file being generated by ASP.NET...
                var xmlFile = $"{Assembly.GetExecutingAssembly().GetName().Name}.XML";
                var xmlPath = Path.Combine(AppContext.BaseDirectory, xmlFile);

                //... and tell Swagger to use those XML comments.
                c.IncludeXmlComments(xmlPath);
            });
        }

        /// <summary>
        /// UseSwagger(IApplicationBuilder app)
        /// </summary>
        /// <returns></returns>
        public void UseSwagger(IApplicationBuilder app)
        {
            //This line enables the app to use Swagger, with the configuration in the ConfigureServices method.
            app.UseSwagger();

            //This line enables Swagger UI, which provides us with a nice, simple UI with which we can view our API calls.
            app.UseSwaggerUI(c =>
            {
                c.SwaggerEndpoint("/swagger/v1/swagger.json", "Swagger XML Api RateMe Demo v1");
            });
        }

        /// <summary>
        /// ConfigureJWT(IServiceCollection services)
        /// </summary>
        /// <returns></returns>
        public void ConfigureJWT(IServiceCollection services)
        {
            services.AddAuthentication(JwtBearerDefaults.AuthenticationScheme)
                    .AddJwtBearer(options =>
                    {
                        options.TokenValidationParameters = new TokenValidationParameters
                        {
                            ValidateIssuer = true,
                            ValidateAudience = true,
                            ValidateLifetime = true,
                            ValidateIssuerSigningKey = true,

                            ValidIssuer = "http://localhost:5000",
                            ValidAudience = "http://localhost:5000",
                            IssuerSigningKey = new SymmetricSecurityKey(Encoding.UTF8.GetBytes("superSecretKey@345"))
                        };
                    });
        }

        /// <summary>
        /// ConfigureCORS(IServiceCollection services)
        /// Configuration for CORS Policy: Cross-Origin Requests
        /// </summary>
        /// <returns></returns>
        public void ConfigureCORS(IServiceCollection services)
        {
            services.AddCors(options =>
            {
                options.AddPolicy("EnableCORS", builder =>
                {
                    builder.AllowAnyOrigin().AllowAnyHeader().AllowAnyMethod().AllowCredentials().Build();
                });
            });
        }
    }
}
